//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <list>
#include <algorithm>

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

class IntSequence {
  private:
    int value;
  public:
    // 
    IntSequence (int initialValue)
     : value(initialValue) {
    }

    // " "
    int operator() () {
        return value++;
    }
};


int main(int argc, char* argv[])
{
  list<int> coll;

  //    1  9
  generate_n (back_inserter(coll),    // 
              9,                      //  
              IntSequence(1));        //  

  PRINT_ELEMENTS(coll," :\n");

  //       ,
  //   42
  generate (++coll.begin(),           // 
            --coll.end(),             // 
            IntSequence(42));         //  

  PRINT_ELEMENTS(coll,"  :\n");

  getch();
  return 0;
}

//---------------------------------------------------------------------------